

;SMART CARD APPLICATIONS
;T.Pratchaya
;<< laplace911@hotmail.com >>
;---------------------------------------
PWR             BIT     P1.6
CRD_IN          BIT     P1.3
CRD_CLK         BIT     P1.2            ;OLD ->P1.5
CRD_RST         BIT     P1.1            ;OLD P1.6
CRD_IO          BIT     P1.0            ;OLD P1.7
;----------------------------------------
                ORG     21H
FLAG:           DS      1
FLAG_PWR        BIT     FLAG.0          ;FLAG POWER ON/OFF CARD
CARD_BUFF:      DS      48
;---------------------------------------

T5_SEC          EQU     08H
T10_SEC         EQU     0FH
READ4436:        
				MOV		P1,#0FFH        
				MOV		P2,#11111110B
				MOV		TMOD,#020H		; T1 8Bit Auto, T0 16Bit
				MOV		TH1,#0FDH		; 9600 bps Timer1 Default
				MOV		TL1,#0FDH		;
				SETB	TR1				; Start Timer1
				MOV		SCON,#040H		; Mode1 RX Disable  
CHK_CARD		JNB		P1.3,$  
                MOV		DPTR,#SHOW_TEXT
                ACALL	TX_TEXT
                LCALL   READ_CARD               ;READ CARD SLE4436 
				LCALL	SHOW_DATA   				
				MOV		DPTR,#PROG_BY_TEXT
				ACALL	TX_TEXT     
				LCALL	CHK_KEY1      
				ACALL	DELAY_100ms
				AJMP	CHK_CARD 
;--------------------------------------
; READ INFORMATION FROM EUROCHIP SLE4436
READ_CARD:
                SETB    FLAG_PWR        ;Set Bit for read card
                LCALL   PWR_CARD        ;ON CARD
                MOV     R0,#CARD_BUFF   ;Reset pointer
                LCALL   CRD_RESET       ;RESET CARD
                MOV     R5,#6           ;6 BYTE
READC:          MOV     R6,#8           ;N-COUNTER FOR READ 8 BIT = 1 BYTE
READI:          LCALL   CRD_READBIT     ;STEP = 1 BYTE RETURN REG 'A'
                MOV     @R0,A           ;Keep in card buffer
                INC     R0
                DJNZ    R6,READI
                DJNZ    R5,READC
                CLR     FLAG_PWR
                LCALL   PWR_CARD        ;OFF CARD
                RET
;------------------------------------------------
;  R7 => COUNTER 8 BIT
;  RETURN OUTPUT REGISTER "A"
;  8 CLOCK READ
;
CRD_READBIT:    MOV     R7,#08          ;8 BIT READ = 1 BYTE
                MOV     A,#0
BITCOUNT:       SETB    CRD_CLK         ;SET 1 CLOCK
                SETB    CRD_IO          ;SET BIT FOR READ
                LCALL   RDCLK           ;DELAY TIME
                CLR     C               ;CLEAR FLAG "C"
                JNB     CRD_IO,ISZERO   ;CHECK = "0" OR = "1"
                SETB    C
ISZERO:         RRC     A               ;SHIFT DATA
                LCALL   RDCLK           ;DELAY TIME
                CLR     CRD_CLK         ;RISE CLOCK
                LCALL   RDCLK           ;DELAY TIME
                DJNZ    R7,BITCOUNT
                RET
;------------------------------------------------
;RESET CARD
CRD_RESET:      SETB    CRD_RST         ;SET IS ACTIVE "HIGH"
                LCALL   READ_CK         ;GENERATE CLOCK
                CLR     CRD_RST         ;RESET IS ACTIVE "LOW"
                LCALL   RDCLK
                RET
;------------------------------------------------
READ_CK:        SETB    CRD_CLK
                LCALL   RDCLK
                CLR     CRD_CLK
                LCALL   RDCLK
                RET
;---------------------------------
;  *** TIMMER 10 USEC
WRCLK:          MOV     B,#T10_SEC
                DJNZ    B,$
                RET
;---------------------------------
; *** TIMMER 5 USEC
;
RDCLK:          MOV     B,#T5_SEC
                DJNZ    B,$
                RET
;------------------------------------------
PWR_CARD:
                SETB    PWR
                JNB     FLAG_PWR,OFF ;Direct to PWR card
                CLR     PWR
OFF:
                MOV     R2,#2           ;WAIT 2 SEC
                LCALL   DTSEC
                RET
;------------------------------------------      
DTSEC:          MOV     R6,#179
DTSEC1:         MOV     R7,#0FFH
                DJNZ    R7,$
                DJNZ    R6,DTSEC1
                DJNZ    R2,DTSEC
                RET          
;----------------------------------------------------------------------------
; Check Key
;----------------------------------------------------------------------------    
CHK_KEY1:		MOV		R0,#CARD_BUFF+3    ;R0 = Pointer
				MOV		DPTR,#KEY1         ;DPTR = Pointer table  
				MOV		R2,#00     ;COUNT FOR COMPARE 4 ADDRESS
CHK_1:			MOV		A,#00
				MOVC	A,@A+DPTR
				MOV		B,@R0        
				CJNE	A,B,CHK_KEY2  
				INC		DPTR
				INC		R0  
				INC		R2   
				CJNE	R2,#4,CHK_1
				SJMP	TURN_ON     
				
CHK_KEY2:		MOV		R0,#CARD_BUFF+3    ;R0 = Pointer
				MOV		DPTR,#KEY2         ;DPTR = Pointer table  
				MOV		R2,#00     ;COUNT FOR COMPARE 4 ADDRESS
CHK_2:			MOV		A,#00
				MOVC	A,@A+DPTR
				MOV		B,@R0        
				CJNE	A,B,CHK_KEY3  
				INC		DPTR
				INC		R0  
				INC		R2   
				CJNE	R2,#4,CHK_2
				SJMP	TURN_ON

CHK_KEY3:		MOV		R0,#CARD_BUFF+3    ;R0 = Pointer
				MOV		DPTR,#KEY3         ;DPTR = Pointer table  
				MOV		R2,#00     ;COUNT FOR COMPARE 4 ADDRESS
CHK_3:			MOV		A,#00
				MOVC	A,@A+DPTR
				MOV		B,@R0        
				CJNE	A,B,CHK_KEY4  
				INC		DPTR
				INC		R0  
				INC		R2   
				CJNE	R2,#4,CHK_3
				SJMP	TURN_ON             
				
CHK_KEY4:		MOV		R0,#CARD_BUFF+3    ;R0 = Pointer
				MOV		DPTR,#KEY4         ;DPTR = Pointer table  
				MOV		R2,#00     ;COUNT FOR COMPARE 4 ADDRESS
CHK_4:			MOV		A,#00
				MOVC	A,@A+DPTR
				MOV		B,@R0        
				CJNE	A,B,TURN_OFF 
				INC		DPTR
				INC		R0  
				INC		R2   
				CJNE	R2,#4,CHK_4
				SJMP	TURN_ON

;----------------------------------------------------------------------------
; Turn On or Turn Off
;----------------------------------------------------------------------------     
TURN_ON:		MOV		P2,#11111101B       ;GREEN
				JB		P1.3,$     
				MOV		P2,#11111110B       ;RED
				RET     
TURN_OFF:		JB		P1.3,$  
				RET	
						

;----------------------------------------------------------------------------
; Display data on Program Hyper terminal
;----------------------------------------------------------------------------
SHOW_DATA:		MOV		A,#CARD_BUFF+48		;Keep end of message pointer    
					
				MOV		R0,#CARD_BUFF	;Reset pointer
SHOW_DATA1:		CLR		TI
					MOV		SBUF,@R0
					JNB		TI,$
					CLR		TI
					INC		R0
					CJNE	A,0,SHOW_DATA1      ;0 Refer to R0 
					RET

;----------------------------------------------------------------------------
; TX Serial Text from ROM Pointer
;----------------------------------------------------------------------------
TX_TEXT:		CLR		TI				; Clear TI
TX_LOOP:		CLR		A				; Clear ACC.
				MOVC	A,@A+DPTR		; Get Data from ROM with Pointer
				INC		DPTR			; Increase Pointer
				CJNE	A,#0FFH,TX_CHAR ; Check 0FFH End of Text Char.
				RET						; End => Return
TX_CHAR:		MOV		SBUF,A			; Send Data to SBUF
				JNB		TI,$			; Wait until TX already (TI=1)
				CLR		TI				; Clear TI
				AJMP	TX_LOOP			; Jump to TX_LOOP

;----------------------------------------------------------------------------
; Dummy Delay time 100m
;----------------------------------------------------------------------------
DELAY_100ms:	MOV		R7,#100			; Do 100 times
DELAY_100ms_1:	MOV		R6,#0E6H		; Each loop = 1 ms
DELAY_100ms_2:	NOP
				NOP
				DJNZ	R6,DELAY_100ms_2
				DJNZ	R7,DELAY_100ms_1
				RET

;----------------------------------------------------------------------------
;Define Constant < Store in Flash EEPROM Program Memory >
;----------------------------------------------------------------------------
SHOW_TEXT:		DB		00AH,00DH
				DB		00AH,00DH
				DB		'Smart Card Reader',00AH,00DH 
				DB		'Read in progress',00AH,00DH
				DB		00AH,00DH,0FFH     
PROG_BY_TEXT:	DB		00AH,00DH         
				DB		'Program By:Pratchaya Tongthong',00AH,00DH           
				DB		'ID:43010256',00AH,00DH  
				DB		00AH,00DH,0FFH 

;----------------------------------------------------------------------------
;Key
;----------------------------------------------------------------------------  
KEY1:           DB		12H,17H,02H,56H
KEY2:			DB		12H,10H,03H,67H
KEY3:			DB		10H,77H,06H,19H
KEY4:			DB      10H,56H,02H,76H
KEY5:			DB      12H,04H,02H,47H          
END